Public Class frm_Main

    Private m_ScanThread As Threading.Thread
    Private WithEvents m_MP3Converter As MP3Converter
    'Private Delegate Sub MessageHandler(ByVal message As String)
    'Dim myHandler As MessageHandler

    Private Sub ButtonMP3_Auswaehlen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMP3_Auswaehlen.Click
        Dim Dlg As New OpenFileDialog
        Dlg.Filter = "MP3-Dateien (*.mp3)|*.mp3"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True

        ' OpenFileDialog zum Auswahl einer MP3-Datei anzeigen
        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim QuellDateiname As String = Dlg.FileName
            ' Wave-Dateiname festlegen
            Dim ZielDateiname As String = IO.Path.GetDirectoryName(QuellDateiname) & "\" & IO.Path.GetFileNameWithoutExtension(QuellDateiname) & ".wav"

            ' neue Instanz der MP3Converter-Klasse erstellen
            m_MP3Converter = New MP3Converter(QuellDateiname, ZielDateiname)
            Me.ButtonMP3_Auswaehlen.Enabled = False
            Me.ButtonAbbrechen.Visible = True

            ' Das Konvertieren soll im Thread erfolgen, um es gegebenenfalls abzubrechen
            m_ScanThread = New Threading.Thread(AddressOf m_MP3Converter.Convert)
            m_ScanThread.Start()

            'Zeitgeber starten, um im 500-ms-Abstand den Fortschritt des Konvertierens
            'abzufragen
            Timer1.Start()

            Do While m_ScanThread.IsAlive
                Application.DoEvents()
            Loop

            Timer1.Stop()

            If Not m_MP3Converter.Aborted Then
                Dim S As Integer = m_MP3Converter.TS.Seconds
                Dim ms As Integer = m_MP3Converter.TS.Milliseconds Mod (S * 1000)
                ' Meldung mit Anzahl Bytes und abgelaufener Zeit anzeigen.
                MessageBox.Show(Me, "Insgesamt wurden " & m_MP3Converter.TotalBytes & " Bytes gelesen." & vbCrLf & _
                "Dauer: " & S & "," & ms & " Sekunden.", "MP3 To Wave Converter", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If


            m_ScanThread = Nothing
            m_MP3Converter = Nothing
            GC.Collect()

            Me.ProgressBar1.Value = 0
            Me.ButtonMP3_Auswaehlen.Enabled = True
            Me.ButtonAbbrechen.Visible = False
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' Fortschrittsanzeige aktualisieren
        If m_MP3Converter IsNot Nothing Then
            Me.ProgressBar1.Value = m_MP3Converter.PercentDone
        End If
    End Sub

    Private Sub ButtonAbbrechen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAbbrechen.Click
        If m_ScanThread IsNot Nothing Then
            m_ScanThread.Abort()
        End If
    End Sub

    Private Sub frm_Main_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If m_ScanThread IsNot Nothing Then
            m_ScanThread.Abort()
        End If
    End Sub
End Class